/* Макросы и переменные сделаны в виде структуры для удобства сворачивания. */

struct{ // Переменные. Обязательно инициализировать перед использованием.
	int cnt;
}vars;

struct{ // Макросы.
	#define SPIDER_ADDR 1
	#define OUTPUT_1	1
	#define OUTPUT_2	2
	#define OUTPUT_3	3
	#define OUTPUT_4	4
	#define INPUT_1		10001
	#define INPUT_2		10002
	#define INPUT_3		10003
	#define INPUT_4		10004
	#define NULL  ((void*)0x00000000)
}defs;

/******************************************************************************************
* Прототип функции main не менять, закрывающую скобку '}' в конце тела функции не ставить *
******************************************************************************************/
void main(
	int *pTmpInt, // Системные переменные, не использовать
	float *pTmpFlt, // Системные переменные, не использовать
  	int (*pInts), /* Указатель на массив целочисленных переменных, доступны через ModBus, 32 бит */
	float (*pFloats), /* Указатель на массив переменных с плавающей точкой, доступны через ModBus, 32 бит */
	int (pKeyH), /* Старшие 32 бита ключа 1-wire */
	int (pKeyL), /* Младшие 32 бита ключа 1-wire */
	int (*pGetNodeVar)( unsigned short dev_addr, unsigned short reg_addr ), /* Чтение переменной из узла  */
	int (*pSetNodeVar)( unsigned short dev_addr, unsigned short reg_addr, unsigned short val ), /* Запись значения переменной в узел */
	int (*pGetTimer)( unsigned short TimerNum ), /* Возвращает значение таймера, (-1) -> выключен */
	int (*pSetTimer)( unsigned short TimerNum, int TimerVal ), /* Возводит таймер, (-1) -> выключен */
	int (*pReceiveSMS)( const char *smsnum, const char *smstext, int *parInt, float *parFlt ),/* Receive SMS */
	int (*pSendSMS)( const char *smsnum, const char *smstext, int *parInt, float *parFlt ), /* Send sms */
	int (*pSendCom2)( const char *TxData, unsigned short TxLen, const char *RxData, unsigned short RxLen), /* Send data over Com2 */
	int (*pTimeCmp)( unsigned char date, unsigned char month, unsigned char year, unsigned char hour, unsigned char minute, unsigned char second, unsigned char day, unsigned char act ), /* Сравнивает время *//* action ( 1'==', 2'!=', 3'>', 4'<' */
	float (*pSinf)(float _X),
	float (*pCosf)(float _X),
	float (*pLogf)(float _X),
	float (*pExpf)(float _X),
	float (*pPowf)(float _X1, float _X2),
	float (*pSqrtf)(float _X)
)
{
/* Тело функции   */







if(((pGetNodeVar(247,49004))==1))
{
pInts[1]=1;
pInts[19]=0;
pInts[18]=0;

}
if(((pGetNodeVar(247,49002))==21) && ((pGetNodeVar(247,49004))==0) && (pInts[1]==1))
{
pInts[1]=0;
pInts[19]=1;
pInts[2]=0;
pInts[3]=0;
pInts[4]=0;
pInts[5]=0;
pInts[6]=0;
pInts[7]=0;
pInts[8]=0;
pInts[9]=0;
pInts[10]=0;
pInts[12]=0;
pSetNodeVar(247,1,0);
pSetNodeVar(247,2,0);
pSetNodeVar(247,3,0);
pSetNodeVar(247,4,0);
pSetNodeVar(247,5,0);
pSetNodeVar(247,6,0);
pSetNodeVar(247,7,0);
pSetNodeVar(247,8,0);
pInts[18]=0;
pInts[0]=(pGetNodeVar(247,49003));
pSetNodeVar(247,49003,0);

}
if((pInts[19]>0))
{
pInts[19]=pInts[19]+1;

}
if((pInts[19]==50) && ((pGetNodeVar(247,49005))==22041))
{
pInts[10]=1;

}
if((pInts[19]==50) && ((pGetNodeVar(247,49008))>45) && ((pGetNodeVar(247,49008))<55))
{
pInts[12]=1;

}
if((pInts[19]==100))
{
pSetNodeVar(247,1,1);

}
if((pInts[19]==200))
{
pSetNodeVar(247,2,1);

}
if((pInts[19]==300))
{
pSetNodeVar(247,3,1);

}
if((pInts[19]==400))
{
pSetNodeVar(247,4,1);

}
if((pInts[19]==500))
{
pSetNodeVar(247,5,1);

}
if((pInts[19]==600))
{
pSetNodeVar(247,6,1);

}
if((pInts[19]==700))
{
pSetNodeVar(247,7,1);

}
if((pInts[19]==800))
{
pSetNodeVar(247,8,1);

}
if((pInts[19]==150) && ((pGetNodeVar(247,10001))==1) && ((pGetNodeVar(247,10002))==0) && ((pGetNodeVar(247,10003))==0) && ((pGetNodeVar(247,10004))==0) && ((pGetNodeVar(247,10005))==0) && ((pGetNodeVar(247,10006))==0) && ((pGetNodeVar(247,10007))==0) && ((pGetNodeVar(247,10008))==0))
{
pInts[2]=1;

}
if((pInts[19]==250) && ((pGetNodeVar(247,10001))==0) && ((pGetNodeVar(247,10002))==1) && ((pGetNodeVar(247,10003))==0) && ((pGetNodeVar(247,10004))==0) && ((pGetNodeVar(247,10005))==0) && ((pGetNodeVar(247,10006))==0) && ((pGetNodeVar(247,10007))==0) && ((pGetNodeVar(247,10008))==0))
{
pInts[3]=1;

}
if((pInts[19]==350) && ((pGetNodeVar(247,10001))==0) && ((pGetNodeVar(247,10002))==0) && ((pGetNodeVar(247,10003))==1) && ((pGetNodeVar(247,10004))==0) && ((pGetNodeVar(247,10005))==0) && ((pGetNodeVar(247,10006))==0) && ((pGetNodeVar(247,10007))==0) && ((pGetNodeVar(247,10008))==0))
{
pInts[4]=1;

}
if((pInts[19]==450) && ((pGetNodeVar(247,10001))==0) && ((pGetNodeVar(247,10002))==0) && ((pGetNodeVar(247,10003))==0) && ((pGetNodeVar(247,10004))==1) && ((pGetNodeVar(247,10005))==0) && ((pGetNodeVar(247,10006))==0) && ((pGetNodeVar(247,10007))==0) && ((pGetNodeVar(247,10008))==0))
{
pInts[5]=1;

}
if((pInts[19]==550) && ((pGetNodeVar(247,10001))==0) && ((pGetNodeVar(247,10002))==0) && ((pGetNodeVar(247,10003))==0) && ((pGetNodeVar(247,10004))==0) && ((pGetNodeVar(247,10005))==1) && ((pGetNodeVar(247,10006))==0) && ((pGetNodeVar(247,10007))==0) && ((pGetNodeVar(247,10008))==0))
{
pInts[6]=1;

}
if((pInts[19]==650) && ((pGetNodeVar(247,10001))==0) && ((pGetNodeVar(247,10002))==0) && ((pGetNodeVar(247,10003))==0) && ((pGetNodeVar(247,10004))==0) && ((pGetNodeVar(247,10005))==0) && ((pGetNodeVar(247,10006))==1) && ((pGetNodeVar(247,10007))==0) && ((pGetNodeVar(247,10008))==0))
{
pInts[7]=1;

}
if((pInts[19]==750) && ((pGetNodeVar(247,10001))==0) && ((pGetNodeVar(247,10002))==0) && ((pGetNodeVar(247,10003))==0) && ((pGetNodeVar(247,10004))==0) && ((pGetNodeVar(247,10005))==0) && ((pGetNodeVar(247,10006))==0) && ((pGetNodeVar(247,10007))==1) && ((pGetNodeVar(247,10008))==0))
{
pInts[8]=1;

}
if((pInts[19]==850) && ((pGetNodeVar(247,10001))==0) && ((pGetNodeVar(247,10002))==0) && ((pGetNodeVar(247,10003))==0) && ((pGetNodeVar(247,10004))==0) && ((pGetNodeVar(247,10005))==0) && ((pGetNodeVar(247,10006))==0) && ((pGetNodeVar(247,10007))==0) && ((pGetNodeVar(247,10008))==1))
{
pInts[9]=1;

}
if((pInts[19]==160))
{
pSetNodeVar(247,1,0);

}
if((pInts[19]==260))
{
pSetNodeVar(247,2,0);

}
if((pInts[19]==360))
{
pSetNodeVar(247,3,0);

}
if((pInts[19]==460))
{
pSetNodeVar(247,4,0);

}
if((pInts[19]==560))
{
pSetNodeVar(247,5,0);

}
if((pInts[19]==660))
{
pSetNodeVar(247,6,0);

}
if((pInts[19]==760))
{
pSetNodeVar(247,7,0);

}
if((pInts[19]==860))
{
pSetNodeVar(247,8,0);

}
if((pInts[19]==900) && (pInts[2]==1) && (pInts[3]==1) && (pInts[4]==1) && (pInts[5]==1) && (pInts[6]==1) && (pInts[7]==1) && (pInts[8]==1) && (pInts[9]==1) && (pInts[10]==1) && (pInts[12]==1))
{
pInts[18]=1;
pInts[19]=0;
pSetNodeVar(247,49003,pInts[0]);

}
if((pInts[11]>=1))
{
pInts[11]=pInts[11]+1;

}
if((pInts[11]==100))
{
pSetNodeVar(247,49023,12345);

}
if((pInts[11]==200))
{
pSetNodeVar(247,49023,54321);
pSetNodeVar(247,49024,54321);
pInts[11]=0;

}
}
